﻿local ARKINV_L = AceLibrary("AceLocale-2.2"):new("ARKINV")

ARKINV = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1" );
local dd = AceLibrary("Dewdrop-2.0");
local gt = AceLibrary("Gratuity-2.0");

ARKINV_G = {

	PROGRAM_NAME = "ArkInventory",
	PROGRAM_VERSION = 1.24,
	DEBUG = false,

	ME = GetRealmName() .. " - " .. UnitName( "player" ),
	CURRENT_USER, -- the current users data to display
	CURRENT_LOCATION, -- the current location to display
	
	MODE_OFFLINE = false,
	MODE_EDIT = false,
	MODE_BANK = false,

	LOCATION_BAG = 1, -- hardcoded, do not change
	LOCATION_BANK = 2, -- hardcoded, do not change
	LOCATION_KEY = 3, -- hardcoded, do not change
	
	LOCATION = {
		[1] = {
			["ORDER"] = 1,
			["NAME"] = ARKINV_L["LOCATION_BAG"],
			["TEXTURE"] = "Interface\\Icons\\INV_Misc_Bag_16",
		},
		[2] = {
			["ORDER"] = 3,
			["NAME"] = ARKINV_L["LOCATION_BANK"],
			["TEXTURE"] = "Interface\\Icons\\INV_Box_03",
		},
		[3] = {
			["ORDER"] = 2,
			["NAME"] = ARKINV_L["LOCATION_KEY"],
			["TEXTURE"] = "Interface\\Icons\\INV_Misc_Key_04",
		},
	},
	
	
	WINDOW_OFFSET = 9, -- hardcoded padding size for gap inside container
	WINDOW_BUSY = false,
	WINDOW_REBUILD = true,
	WINDOW_REFRESH = true,
	WINDOWS_OFFLINE = false,
	
	WINDOW_MIN_ROW = 1,
	WINDOW_MIN_COL = 6,
	
	WINDOW_MAX_BAR = 0,
	WINDOW_MAX_SLOT = 0,
	
	FADE_ALPHA = 0.4,
	
	BAG_SLOT_SIZE = 40,
	
	-- slot type numbers, do not change this order, just add new ones to the end of the list
	SLOT_UNKNOWN = 0,
	SLOT_NORMAL = 1,
	SLOT_BANK = 2,
	SLOT_KEY = 3,
	SLOT_PROJECTILE = 4,
	SLOT_SOUL = 5,
	SLOT_HERB = 6,
	SLOT_ENCHANTING = 7,
	SLOT_ENGINEERING = 8,
	SLOT_GEM = 9,
	SLOT_MINING = 10,

	CONTAINER_IDS_BAG = { -2, 0, 1, 2, 3, 4 },
	CONTAINER_IDS_BANK = { -1, 5, 6, 7, 8, 9, 10, 11 },
	
	GUI_NAME = "ARKINV_Ui",
	GUI,

	SLOT_DEFAULT_EMPTY_COLOURS = {
		["unknown"] = { r = 1.0, g = 0.0, b = 0.0 },
		["normal"] = { r = 0.3, g = 0.3, b = 0.3 },
		["bank"] = { r = 1.0, g = 1.0, b = 1.0 },
		["key"] = { r = 1.0, g = 1.0, b = 1.0 },
		["projectile"] = { r = 1.0, g = 0.5, b = 0.0 }, -- orange
		["soul"] = { r = 1.0, g = 0.0, b = 1.0 }, -- purple
		["herb"] = { r = 0.0, g = 0.5, b = 0.0 }, -- green
		["enchanting"] = { r = 0.0, g = 0.0, b = 0.5 }, -- blue
		["engineering"] = { r = 1.0, g = 1.0, b = 1.0 },
		["gem"] = { r = 1.0, g = 1.0, b = 1.0 },
		["mining"] = { r = 1.0, g = 1.0, b = 1.0 },
	},

	BAR_DEFAULT_COLOUR = { r = 0.0, g = 0.0, b = 0.4, a = 0.4 },
	
	SLOT_SORT_NONE = 0,
	SLOT_SORT_NAME = 1,
	SLOT_SORT_BAGSLOT = 2,
	
	CATEGORY = { }, -- see GenerateCategory()
	
	CATEGORY_SYSTEM = { -- do NOT change the order
		[0] = ARKINV_L["CATEGORY_DEFAULT"],
		[1] = ARKINV_L["CATEGORY_TRASH"],
		[2] = ARKINV_L["CATEGORY_EMPTY"],
		[3] = ARKINV_L["CATEGORY_EMPTY_KEY"],
		[4] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE"],
		[5] = ARKINV_L["CATEGORY_EMPTY_SOUL"],
		[6] = ARKINV_L["CATEGORY_EMPTY_HERB"],
		[7] = ARKINV_L["CATEGORY_EMPTY_ENCHANTING"],
		[8] = ARKINV_L["CATEGORY_EMPTY_ENGINEERING"],
		[9] = ARKINV_L["CATEGORY_EMPTY_GEM"],
		[10] = ARKINV_L["CATEGORY_EMPTY_MINING"],
		[11] = ARKINV_L["CATEGORY_SOULBOUND"],
		[12] = ARKINV_L["CATEGORY_CONSUMABLE"],
		[13] = ARKINV_L["CATEGORY_CONTAINER"],
		[14] = ARKINV_L["CATEGORY_KEY"],
		[15] = ARKINV_L["CATEGORY_MISCELLANEOUS"],
		[16] = ARKINV_L["CATEGORY_REAGENT"],
		[17] = ARKINV_L["CATEGORY_RECIPE"],
		[18] = ARKINV_L["CATEGORY_PROJECTILE"],
		[19] = ARKINV_L["CATEGORY_QUEST"],
		[20] = ARKINV_L["CATEGORY_TRADE_GOODS"],
		[22] = ARKINV_L["CATEGORY_SOUL"],
		[23] = ARKINV_L["CATEGORY_EQUIPMENT"],
		[24] = ARKINV_L["CATEGORY_MOUNT"],
		[25] = ARKINV_L["CATEGORY_SOULBOUND_EQUIPMENT"],
	},

	CATEGORY_PROFESSION = { -- do NOT change the order
		[101] = ARKINV_L["CATEGORY_PROFESSION_HERBALISM"],
		[102] = ARKINV_L["CATEGORY_PROFESSION_FISHING"],
		[103] = ARKINV_L["CATEGORY_PROFESSION_MINING"],
		[104] = ARKINV_L["CATEGORY_PROFESSION_SKINNING"],
		[105] = ARKINV_L["CATEGORY_PROFESSION_ALCHEMY"],
		[106] = ARKINV_L["CATEGORY_PROFESSION_BLACKSMITHING"],
		[107] = ARKINV_L["CATEGORY_PROFESSION_COOKING"],
		[108] = ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"],
		[109] = ARKINV_L["CATEGORY_PROFESSION_LEATHERWORKING"],
		[110] = ARKINV_L["CATEGORY_PROFESSION_TAILORING"],
		[111] = ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"],
		[112] = ARKINV_L["CATEGORY_PROFESSION_FIRST_AID"],
		[113] = ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"],
	},
	
	CATEGORY_CLASS = { -- do NOT change the order
		[201] = ARKINV_L["CATEGORY_CLASS_DRUID"],
		[202] = ARKINV_L["CATEGORY_CLASS_HUNTER"],
		[203] = ARKINV_L["CATEGORY_CLASS_MAGE"],
		[204] = ARKINV_L["CATEGORY_CLASS_PALADIN"],
		[205] = ARKINV_L["CATEGORY_CLASS_PRIEST"],
		[206] = ARKINV_L["CATEGORY_CLASS_ROGUE"],
		[207] = ARKINV_L["CATEGORY_CLASS_SHAMAN"],
		[208] = ARKINV_L["CATEGORY_CLASS_WARLOCK"],
		[209] = ARKINV_L["CATEGORY_CLASS_WARRIOR"],
	},
	
}


-- Binding Variables
BINDING_HEADER_ARKINV = ARKINV_G.PROGRAM_NAME;
BINDING_NAME_ARKINV_OPEN_BAG = ARKINV_L["BINDING_TOGGLE"];


ARKINV:RegisterDB( "ARKINVDB" );

ARKINV:RegisterDefaults( "profile", {
	["option"] = {
		["window"] = {
			["scale"] = 1,
			["col"] = 12,
			["colour"] = {
				["background"] = {
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
					["a"] = 0.75,
				},
			},
			["auto"] = {
				["open"] = {
					["bank"] = true,
					["mail"] = true,
					["trade"] = true,
					["merchant"] = true,
					["auction"] = true,
				},
				["close"] = {
					["bank"] = true,
					["mail"] = true,
					["trade"] = true,
					["merchant"] = true,
					["auction"] = true,
					["combat"] = true,
				},
			},
		},
		["bar"] = {
			["per"] = 3,
			["pad"] = 0,
			["border"] = false,
			["colour"] = {
				["background"] = ARKINV_G.BAR_DEFAULT_COLOUR,
				["border"] = ARKINV_G.BAR_DEFAULT_COLOUR,
			},
		},
		["slot"] = {
			["empty"] = {
				["alpha"] = 0.1,
				["icon"] = true,
				["colour"] = ARKINV_G.SLOT_DEFAULT_EMPTY_COLOURS,
				["clump"] = false,
			},
			["pad"] = 2,
			["border"] = true,
			["new"] = false,
			["sort"] = ARKINV_G.SLOT_SORT_NAME,
			["fade"] = true,
		},
		["category"] = {
			["location"] = { -- [category id] = bar number
				[0] = 1,
			},
			["custom"] = {
				[-1] = "CUSTOM 1",
				[-2] = "CUSTOM 2",
				[-3] = "CUSTOM 3",
				[-4] = "CUSTOM 4",
				[-5] = "CUSTOM 5",
				[-6] = "CUSTOM 6",
				[-7] = "CUSTOM 7",
				[-8] = "CUSTOM 8",
				[-9] = "CUSTOM 9",
			},
			["next"] = -10,  -- id for next custom category
			["item"] = { -- ["itemnumber"] = category id
			},
		},
	},

} );

ARKINV:RegisterDefaults( "account", {
	["cache"] = {
		["who"] = {
			["*"] = {
				["location"] = {
					["*"] = {
						["inventory"] = {
							["bag"] = { },
							["bar"] = { },
							["container"] = { },
						},
						["slot_count"] = 0,
						["bar_count"] = 0,
						["last_update"] = 0,
					},
				},
			},
		},
	},
	
} );



local ARKINV_SlashCommandOptions = {
	type = "group",
	args = {

		gui = {
			type = "group",
			name = "gui",
			desc = "gui options",
			args = {
				show = {
					type = "toggle",
					name = "show",
					desc = "show / hide the user interface",
					get = function() return ARKINV_Ui:IsVisible() end, 
					set = function() ARKINV:UiToggle() end,
				},
				reset = {
					type = "execute",
					name = "reset",
					desc = "center the user interface on the screen",
					func = function() ARKINV_Ui:SetPoint( "TOPLEFT", UiParent, "CENTER" ) end
				},
			},
		},
		
		db = {
			type = "group",
			name = "db",
			desc = "db options",
			args = {
				reset = {
					type = "group",
					name = "reset",
					desc = "resets all user options back to the defaults",
					args = {
						confirm = {
							type = "execute",
							name = "confirm",
							desc = "confirms the database reset",
							func = function() ARKINV:ReloadDatabase() end
						},
					},
				},
			},
		},
		
		cache = {
			type = "group",
			name = "cache",
			desc = "cache options",
			args = {
				erase = {
					type = "group",
					name = "erase",
					desc = "erases all cached data",
					args = {
						confirm = {
							type = "execute",
							name = "confirm",
							desc = "confirms the cache erase",
							func = function() ARKINV:ReloadCache() end
						},
					},
				},
			},
		},

	},
}

ARKINV:RegisterChatCommand( { "/arkinv", "/ai" }, ARKINV_SlashCommandOptions )


function ARKINV:DefaultOptionBar()

	self.db.profile.option["bar"] = { }
	
end


function ARKINV:DefaultOptionSlot()

	self.db.profile.option["slot"] = { }

end


function ARKINV:ReloadDatabase()

	self:ResetDB( "profile" );
	self:Print( "Database has been reset." );
	self:Print( "All user options are back at factory defaults." )
	
	self:GenerateCategory();
	self:ScanContainerAll();
	self:UiClose();

end


function ARKINV:ReloadCache()

	self:ResetDB( "account" );
	self:Print( "All cached data has been erased." )
	
	self:GenerateCategory();
	self:ScanContainerAll();
	self:UiClose();

end










function ARKINV:Debug( msg )
	if ARKINV_G.DEBUG == true then
		if ( DEFAULT_CHAT_FRAME ) then
			if not colour then
				ARKINV:Print( msg )
			else
				ARKINV:Print( colour_code .. msg .. FONT_COLOR_CODE_CLOSE )
			end
		end
	end
end

function ARKINV:tableSum( tbl, fcn ) --fcn(v)
	local r = 0
	for k, v in pairs( tbl ) do
		r = r + ( fcn( v ) or 0 )
	end
	return r
end

function ARKINV:tableMax( tbl, fcn )
	local r = nil
	for k, v in pairs( tbl ) do
		if not r then
			r = ( fcn( v ) or 0 )
		else
			if ( fcn( v ) or 0 ) > r then
				r = ( fcn( v ) or 0 )
			end
		end
	end
	return r
end

function ARKINV:tableElements( tbl )
	local r = 0
	for _, _ in pairs( tbl ) do
		r = r + 1;
	end
	return r
end




function ARKINV:spairs( tbl, comparator )

	local sortedKeys = {};
	for k, v in pairs( tbl ) do
		tinsert( sortedKeys, k )
	end;
	sort( sortedKeys, comparator );
	local i = 0;
	local function _f( _s, _v )
		i = i + 1;
		local k = sortedKeys[i];
		if ( k ) then
			return k, tbl[k];
		end
	end
	return _f, nil, nil;
end







function ARKINV:OnInitialize()
	-- Called when the addon is loaded

	-- set current display to current user
	ARKINV_G.CURRENT_USER = ARKINV_G.ME;
	ARKINV_G.CURRENT_LOCATION = ARKINV_G.LOCATION_BAG;


	ARKINV_G.GUI = getglobal( ARKINV_G.GUI_NAME );
	
	randomseed( time() );
	
	self:RemoveOldOptions();

end


function ARKINV:OnEnable()
	-- Called when the addon is enabled


	self:GenerateCategory();

	self:ScanContainerAll();
	

	self:RegisterEvent( "BAG_UPDATE" );
	self:RegisterEvent( "BAG_UPDATE_COOLDOWN" );
	self:RegisterEvent( "ITEM_LOCK_CHANGED" );
	
	self:RegisterEvent( "PLAYERBANKSLOTS_CHANGED" ); -- one of the slots in bag -1 (main bank) have changed

	self:RegisterEvent( "PLAYER_REGEN_DISABLED" ); -- player about to enter combat

	self:RegisterEvent( "BANKFRAME_OPENED" );
	self:RegisterEvent( "BANKFRAME_CLOSED" );
	
	self:RegisterEvent( "MAIL_SHOW" );
	self:RegisterEvent( "MAIL_CLOSED" );

	self:RegisterEvent( "TRADE_SHOW" );
	self:RegisterEvent( "TRADE_CLOSED" );

	self:RegisterEvent( "AUCTION_HOUSE_CLOSED" );
	self:RegisterEvent( "AUCTION_HOUSE_SHOW" );

	self:RegisterEvent( "MERCHANT_SHOW" );
	self:RegisterEvent( "MERCHANT_CLOSED" );
	
	
	
	

	--self:RegisterEvent( "UNIT_INVENTORY_CHANGED" );  -- not triggering on bag changes
	--self:RegisterEvent( "UPDATE_INVENTORY_ALERTS" ); -- currently equipped has changed (doesn't seem to include bag slots)
	

	--"PLAYER_LOGIN" --Triggered immediately before PLAYER_ENTERING_WORLD on login and UI Reload, but NOT when entering/leaving instances.
	-- "PLAYER_LOGOUT" -- Sent when the player logs out or the UI is reloaded, after PLAYER_LEAVING_WORLD, but before variables are saved.

	--self:SecureHook( "ToggleBackpack", "UiOpen" );

	self:Print( "v" .. ARKINV_G.PROGRAM_VERSION .. " Enabled.  Type /ARKINV or /AI for help." )
	
end


function ARKINV:OnDisable()
	-- Called when the addon is disabled

	self:UnhookAll();
	
	self:UiClose();
	
	self:Debug( "Disabled" )
end


function ARKINV:BAG_UPDATE( arg1 )
	self:Debug( RED_FONT_COLOR_CODE .. "BAG_UPDATE( " .. arg1 .. " )" );
	-- a bag just had it's contents changed, usually triggers in pairs
	
	if arg1 == 0 then
		self:ScanContainerAll();
	else
		self:ScanContainer( arg1 );
	end
	self:GenerateContainer();
end

function ARKINV:BAG_UPDATE_COOLDOWN( arg1 )
	self:Debug( RED_FONT_COLOR_CODE .. "BAG_UPDATE_COOLDOWN" );
	self:ScanContainer( arg1 );
	self:GenerateContainer();
end

function ARKINV:ITEM_LOCK_CHANGED( arg1 )
	self:Debug( RED_FONT_COLOR_CODE .. "ITEM_LOCK_CHANGED" );
	-- you just clicked on an item
	ARKINV_G.WINDOW_REFRESH = true;
	self:GenerateContainer();
end






function ARKINV:PLAYER_REGEN_DISABLED()
	if self.db.profile.option.window.auto.close.combat == true then
		self:UiClose();
	end
end

function ARKINV:BANKFRAME_OPENED()

	self:Debug( RED_FONT_COLOR_CODE .. "BANKFRAME_OPENED" );
	
	ARKINV_G.MODE_BANK = true;
	
	self:ScanContainerAll();
		
	if self.db.profile.option.window.auto.open.bank == true then
		self:UiOpen( ARKINV_G.LOCATION_BANK, ARKINV_G.ME );
	else
		-- regenerate the view in case they were looking at the bank "offline", make it "online"
		self:GenerateContainer();
	end
	
end

function ARKINV:BANKFRAME_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "BANKFRAME_CLOSED" );
	
	ARKINV_G.MODE_BANK = false;

	self:GenerateContainerRefresh();
	
	if self.db.profile.option.window.auto.close.bank == true then
		self:UiClose();
	end

end

function ARKINV:PLAYERBANKSLOTS_CHANGED()
	self:Debug( RED_FONT_COLOR_CODE .. "PLAYERBANKSLOTS_CHANGED" );
	self:ScanContainerAll();
	self:GenerateContainer();
end


function ARKINV:MAIL_SHOW()

	self:Debug( RED_FONT_COLOR_CODE .. "MAIL_SHOW" );

	if self.db.profile.option.window.auto.open.mail == true then
		self:UiOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
	end

end

function ARKINV:MAIL_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "MAIL_CLOSED" );
	
	if self.db.profile.option.window.auto.close.mail == true then
		self:UiClose();
	end

end

function ARKINV:TRADE_SHOW()

	self:Debug( RED_FONT_COLOR_CODE .. "TRADE_SHOW" );
	
	if self.db.profile.option.window.auto.open.trade == true then
		self:UiOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
	end

end

function ARKINV:TRADE_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "TRADE_CLOSED" );
	
	if self.db.profile.option.window.auto.close.trade == true then
		self:UiClose();
	end

end

function ARKINV:AUCTION_HOUSE_SHOW()

	self:Debug( RED_FONT_COLOR_CODE .. "AUCTION_HOUSE_SHOW" );
	
	if self.db.profile.option.window.auto.open.auction == true then
		self:UiOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
	end

end

function ARKINV:AUCTION_HOUSE_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "AUCTION_HOUSE_CLOSED" );
	
	if self.db.profile.option.window.auto.close.auction == true then
		self:UiClose();
	end

end

function ARKINV:MERCHANT_SHOW()

	self:Debug( RED_FONT_COLOR_CODE .. "MERCHANT_SHOW" );
	
	if self.db.profile.option.window.auto.open.merchant == true then
		self:LocationChange( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
		self:UiOpen();
	end

end

function ARKINV:MERCHANT_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "MERCHANT_CLOSED" );
	
	if self.db.profile.option.window.auto.close.merchant == true then
		self:UiClose();
	end

end

function ARKINV:UiOpen( location, user )

	self:LocationChange( location, ARKINV_G.ME );

	ARKINV_G.GUI:Show();
	self:GenerateContainer();
	
end

function ARKINV:UiClose()

	ARKINV_G.GUI:Hide();
	
	-- set current display to current user
	--self:LocationChange( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
	
	-- disable edit mode and taint window when closed so it's rebuilt when next opened
	if ARKINV_G.MODE_EDIT == true then
		ARKINV_G.MODE_EDIT = false;
		ARKINV_G.WINDOW_REBUILD = true;
	end
	
end

function ARKINV:UiToggle()
	if ARKINV_G.GUI:IsVisible() then
		self:UiClose()
	else
		self:UiOpen()
	end
end


function ARKINV:ScanContainerAll()

	self:Debug( "ScanContainerAll() start" );

	for _, id in pairs( ARKINV_G.CONTAINER_IDS_BAG ) do
		self:ScanContainer( id );
	end
	
	if ARKINV_G.MODE_BANK then
		for _, id in pairs( ARKINV_G.CONTAINER_IDS_BANK ) do
			self:ScanContainer( id );
		end
	end
	
	self:Debug( "ScanContainerAll() end" );
	
end


function ARKINV:ScanContainer( bagnum )

	if not ( bagnum ) then
		return
	end

	
	self:Debug( "ScanContainer( " .. bagnum .. " ) start" )

	local bl = self:BagLocation( bagnum );
	if not bl then
		return
	end
	
	if bl == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE_BANK == false then
		self:Debug( "aborted scan of bag " .. bagnum .. ", not at bank" )
		return
	end

	
	ARKINV_G.WINDOW_REBUILD = true
	ARKINV_G.WINDOW_REFRESH = true

	--self.db.account.cache.who[user].location[bl].inventory.bag
	local bag = { }
	bag["count"] = GetContainerNumSlots( bagnum );
	bag["empty"] = 0
	bag["type"] = self:BagType( bagnum )
	bag["slot"] = { }
	
	local i, locked, readable

	--self:Debug( "bag " .. bagnum .. " has " .. bag.count .. " slots" )
	
	for slotnum = 1, bag.count do
	
		i = { }
		
		i["h"] = GetContainerItemLink( bagnum, slotnum );
		
		if i.h then
			i["texture"], i["count"], locked, _, readable = GetContainerItemInfo( bagnum, slotnum );
			i["name"], _, i["q"] = GetItemInfo( i.h );
			i["id"] = strmatch( i.h, "|Hitem:(%d+):" );
			
			if locked then i["locked"] = 1; end
			if readable then i["readable"] = 1; end
			
		else
			-- empty slot
			bag.empty = bag.empty + 1
		end

		if not i.name then i.name = ""; end
		if not i.count then i.count = 0; end
		if not i.q then i.q = 0; end
		if not i.id then i.id = "0"; end
		
		if self:ItemSoulbound( i, bagnum, slotnum ) == true then
			self:Debug( "soulbound, bag=" .. bagnum .. ", slot=" .. slotnum .. ", link=" .. i.h )
			i["sb"] = true
		end

		i["cat"], i["catdef"] = self:ItemCategoryGet( i, bag.type, bagnum, slotnum )

		
		--self:Debug( "bag=" .. bagnum .. ", type=" .. bag.type .. ", slot=" .. slotnum .. ", name=" .. i.name .. ", cat=" .. i.cat )
		
		--{ ["h"]=h, ["id"]=k, ["name"]=name, ["q"]=quality, ["count"]=count, ["cat"]=cat, ["catdef"]=catdef, ["texture"]=texture, ["locked"]=locked, ["readable"]=readable, ["sb"]=soulbound }
		bag.slot[slotnum] = i;

	end

	self.db.account.cache.who[ARKINV_G.ME].location[bl].inventory.bag[bagnum] = bag
	--self.db.account.cache.who[ARKINV_G.ME].location[bl].last_update = 
	
	self:Debug( "ScanContainer( " .. bagnum .. " ) end" );
	
end


function ARKINV:SetCategoryLocation( category_id, barnum )
	self.db.profile.option.category.location[category_id] = barnum
end


function ARKINV:GetCategoryLocation( category_id )
	-- maps category id's to the bars they are assigned to
	if not self.db.profile.option.category.location[category_id] then
		-- if this category hasn't been assigned to a bar then return the bar that DEFAULT is using
		return self.db.profile.option.category.location[0]
	else
		return self.db.profile.option.category.location[category_id]
	end
end


function ARKINV:CalculateBars()

	self:Debug( "CalculateBars() start" )

	self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar = { }
	self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count = 15;
	
	local barnum;

	-- load the inventory into their respective bars
	for bagnum, bag in pairs( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bag ) do
	
		for slotnum, slot in pairs( bag.slot ) do
		
			barnum = self:GetCategoryLocation( slot.cat )
	
			-- create the bar
			if not self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[barnum] then
				self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 0, ["width"] = 0, ["height"] = 0, ["frame"] = 0, ["ghost"] = false };
			end
		
			-- add the item to the bar
			tinsert( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[barnum].item, { ["bag"] = bagnum, ["slot"] = slotnum } )
			
			-- increment the bars item count
			self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[barnum].count = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[barnum].count + 1
			
			-- keep track of the last bar used
			if barnum > self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count then
				self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count = barnum
			end

			--self:Debug( "bag[" .. bagnum .. "], slot[" .. slotnum .. "], cat[" .. slot.cat .. "], bar[" .. barnum .. "], id=[" .. vb[barnum].id .. "]" )
			
		end
		
	end

	-- round up to a full number of bars per row
	self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count = ceil( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count / self.db.profile.option.bar.per ) * self.db.profile.option.bar.per
	
	-- update the maximum number of bar frames used so far
	if self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count > ARKINV_G.WINDOW_MAX_BAR then
		ARKINV_G.WINDOW_MAX_BAR = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count
	end
	
	-- if we're in edit mode then create 1 slot bars for any empty ones
	if ARKINV_G.MODE_EDIT == true then
		self:Debug( "edit mode - adding ghost bars" );
		for barnum = 1, self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count do
			if not self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[barnum] then
				self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 1, ["width"] = 0, ["height"] = 0, ["frame"] = 0, ["ghost"] = true };
			end
		end
	end
	
	self:Debug( "CalculateBars() end" )
	
end


function ARKINV:CalculateContainer()

	self:Debug( "CalculateContainer() start" )

	self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container = { ["row"] = { } }
	
	local bpr = self.db.profile.option.bar.per
	local rownum = 0
	local bf = 1 -- bar frame, allocated to each bar as it's calculated (uses less frames this way)
	
	self:Debug( "container has " .. self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count .. " bars" )
	self:Debug( "container set for " .. bpr .. " bars per row" )
	
	for j = 1, self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count, bpr do
		
		local bc = 0  -- number of bars in this row
		local vr = { }  -- virtual row - holds a list of bars for this row

		for b = 1, bpr do
			if self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[j+b-1] then
				if self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[j+b-1].count > 0 then
					-- self:Debug( "assignment: bar=" .. j+b-1 .. ", frame=" .. bf )
					self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[j+b-1]["frame"] = bf
					bf = bf + 1
					bc = bc + 1
					tinsert( vr, self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bar[j+b-1] )
				else
					-- self:Debug( "bar " .. j+b-1 .. " has no items" )
				end
			else
				-- self:Debug( "bar " .. j+b-1 .. " does not exist" )
			end
		end
		
		-- self:Debug( "row " .. rownum .. " allocated " .. bc .. " bars" )
		
		if bc > 0 then
		
			rownum = rownum + 1
			if not self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row[rownum] then
				self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row[rownum] = { }
			end
			
			self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row[rownum].bar = vr

		end

	end

	
	-- fit the bars into the row

	local rmw = self.db.profile.option.window.col  -- row max width
	local rcw = 0 -- row current width
	local rch = 1 -- row current height
	local rmh = 0 -- row max height
		
	for rownum, row in ipairs( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row ) do
			
		for bagnum, bar in ipairs( row.bar ) do

			-- self:Debug( "row=" .. rownum .. ", bag=" .. bagnum )
			
			bar.width = floor( bar.count / rmw )
			if bar.width < 1 then
				bar.width = 1
			end
			
			bar.height = ceil( bar.count / bar.width )
				
			if bar.height > rmh then
				rmh = bar.height
			end
				
		end
			
		if rmh > 1 then

			repeat
			
				rcw = 0
				rmh = 0
				rmb = 0
				
				-- find bar with highest height
				for barnum, bar in ipairs( row.bar ) do
					if bar.height > rmh then
						rmh = bar.height
						rmb = barnum
					end
				end

				-- increase that bars width by one
				row.bar[rmb].width = row.bar[rmb].width + 1
				
				-- and recalcualte it's new height
				row.bar[rmb].height = ceil( row.bar[rmb].count / row.bar[rmb].width )
				
				-- and see if that all fits
				rcw = self:tableSum( row.bar, function( a ) return a.width; end );
				
				rmh = self:tableMax( row.bar, function( a ) return a.height; end );
					
				-- exit if the width fits or the max height is 1
			until rcw >= rmw or rmh == 1
			
		end
			
		--self:Debug( "maximum height for row " .. rownum .. " was " .. rmh )
		for _, bar in pairs( row.bar ) do
			-- set height of all bars in the row to the maximum height used (looks better)
			bar.height = rmh
			
			-- reset item count to zero for ghost bars
			if bar.ghost == true then
				bar.count = 0
			end
		end
		
	end
		
	self:Debug( "CalculateContainer() end" )

end


function ARKINV:FrameUpdate()

	local p = ARKINV_G.GUI:GetName()
	
	-- set dragable frame width
	ARKINV_G.GUI:SetWidth( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.width );

	local sf = getglobal( p .. "Status" )
	
	-- adjust gold frame
	local mf = getglobal( p .. "MoneyFrame" )
	mf:SetPoint( "RIGHT", sf:GetName(), "RIGHT" )

	-- update the empty slot count
	local empty = { }
	local st = getglobal( p .. "StatusText" )
	for _, bag in pairs( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bag ) do
		if not empty[bag.type] then
			empty[bag.type] = { ["count"] = 0, ["empty"] = 0 }
		end
		empty[bag.type].count = empty[bag.type].count + bag.count
		empty[bag.type].empty = empty[bag.type].empty + bag.empty
	end

	name = sf:GetName() .. "Text"
	obj = getglobal( name )
	if not obj then
		obj = sf:CreateFontString( name, "ARTWORK", "GameFontNormal" );
		obj:SetPoint( "LEFT", sf, "LEFT", ARKINV_G.WINDOW_OFFSET, 0 );
		obj:SetTextColor( 1, 1, 1, 1 );
	end
	
	local ee = self:tableSum( empty, function( a ) return a.empty; end );
	y = "";
	if ee == 0 then
		y = y .. RED_FONT_COLOR_CODE .. "FULL";
	else
		y = y .. ee .. "/" .. self:tableSum( empty, function( a ) return a.count; end );
	end
	
	if self:tableElements( empty ) > 1 then
		local z = 0
		local x
		y = y .. "  -  "
		for t, e in pairs( empty ) do
			z = z + 1
			--x = e.empty .. "/" .. e.count .. " " .. self:BagTypeText( t )
			x = e.empty .. " " .. self:BagTypeText( t )
			if e.empty == 0 then
				x = RED_FONT_COLOR_CODE .. x .. FONT_COLOR_CODE_CLOSE
			end
			
			if z == 1 then
				y = y .. x
			else
				y = y .. ", " .. x
			end
			
		end
	end
	obj:SetText( y )
	
end


function ARKINV:GenerateCategory()

	categories = {
		[ARKINV_L["CATEGORY_SYSTEM"]] = ARKINV_G.CATEGORY_SYSTEM,
		[ARKINV_L["CATEGORY_PROFESSION"]] = ARKINV_G.CATEGORY_PROFESSION,
		[ARKINV_L["CATEGORY_CLASS"]] = ARKINV_G.CATEGORY_CLASS,
		[ARKINV_L["CATEGORY_CUSTOM"]] = self.db.profile.option.category.custom,
	}
	
	ARKINV_G.CATEGORY = { }

	for name, category in pairs( categories ) do
		for k, v in pairs( category ) do
			tinsert( ARKINV_G.CATEGORY, { ["id"]=k, ["name"]=v, ["type"]="CATEGORY_" .. name } )
		end
	end

end

function ARKINV:GetCategoryName( category_id )

	for _, v in pairs( ARKINV_G.CATEGORY ) do
		if category_id == v.id then
			return v.name
		end
	end

	return ( "UNKNOWN CATEGORY [" .. category_id .. "]" )
	
end


function ARKINV:GenerateBar( bar, frame, boffset )

	--self:Debug( "bar=" .. bar.frame .. ", parent=" .. frame:GetName() .. ", boffset=" .. boffset )
	
	if bar.count == 0 or bar.ghost == true then
		return
	end
	
	local parent = frame:GetParent():GetName()
	local name = frame:GetName()
	
	local obj
	
	local pad_slot = self.db.profile.option.slot.pad
	local pad_bar = self.db.profile.option.bar.pad
	local col = bar.width
	local i, z, t
	
	-- sort the table
	for j = 1, bar.count do
	
		i = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bag[bar.item[j].bag].slot[bar.item[j].slot]
		
		if i.name == "" then
			t = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bag[bar.item[j].bag].type
		else
			t = ARKINV_G.SLOT_NORMAL
		end
		
		-- set sort key
		if self.db.profile.option.slot.sort == ARKINV_G.SLOT_SORT_NAME then
			-- name
			bar.item[j]["sort"] = i.name .. "!" .. format( "%04i", t ) .. "!" .. format( "%04i", i.count )
			--i.cat .. "!" .. format( "%04i", t ) .. "!" .. i.name .. "!" .. format( "%04i", i.count ) .. "!" .. format( "%04i", bar.item[j].bag ) .. "!" .. format( "%04i", bar.item[j].slot )
		elseif self.db.profile.option.slot.sort == SLOT_SORT_BAGSLOT then
			bar.item[j]["sort"] = format( "%04i", bar.item[j].bag ) .. "!" .. format( "%04i", bar.item[j].slot )
		else
			-- none (you really don't want to use this one as it's random every time)
			bar.item[j]["sort"] = ""
		end
		
	end
	
	sort( bar.item, function( a, b ) return a.sort > b.sort end )
	

	local texture, count, locked, quality, readable
	
	-- build the items in the bar
	for j = 1, bar.count do
	
		z = j + boffset
		i = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bag[bar.item[j].bag].slot[bar.item[j].slot]
	
		--self:Debug( "obj=" .. parent .. "Item" .. z .. ", bag=" .. item.bag .. ", slot=" .. item.slot )
		
		obj = getglobal( parent .. "Item" .. z );

		getglobal( obj:GetName() .. "ArkBag" ):SetText( bar.item[j].bag )
		getglobal( obj:GetName() .. "ArkSlot" ):SetText( bar.item[j].slot )
		
		
		-- anchor first item to bar frame
		if ( j == 1 ) then
			obj:SetPoint( "BOTTOMRIGHT", name, "BOTTOMRIGHT", 0 - pad_slot - ARKINV_G.WINDOW_OFFSET, pad_slot + ARKINV_G.WINDOW_OFFSET );
		else
			if ( mod( ( j - 1 ), col ) == 0 ) then
				-- next row, place above first item in previous row
				obj:SetPoint( "BOTTOMRIGHT", parent .. "Item" .. ( z - col ), "TOPRIGHT", 0, pad_slot );
			else
				-- place next to last one
				obj:SetPoint( "BOTTOMRIGHT", parent .. "Item" .. ( z - 1 ), "BOTTOMLEFT", 0 - pad_slot, 0 );
			end
		end

		SetItemButtonTexture( obj, i.texture );
		SetItemButtonCount( obj, i.count );
		SetItemButtonDesaturated( obj, i.locked, 0.5, 0.5, 0.5 );

		
		if i.q > 0 and self.db.profile.option.slot.border == true then
			local r, g, b = GetItemQualityColor( i.q );
			getglobal( obj:GetName() .. "Ark" ):SetBackdropBorderColor( r, g, b, 1 );
		else
			getglobal( obj:GetName() .. "Ark" ):SetBackdropBorderColor( 0.5, 0.5, 0.5, 1 );
		end

		
		if ARKINV_G.MODE_OFFLINE and self.db.profile.option.slot.fade == true then
			obj:SetAlpha( ARKINV_G.FADE_ALPHA );
		else
			obj:SetAlpha( 1 );
		end
		
		
		if ( i.texture ) then
		
			getglobal( obj:GetName() .. "ArkBackground" ):SetTexture( 0, 0, 0, 0 );
			
			self:UpdateCooldown( obj );
			obj.hasItem = 1;

		else
			
			getglobal( obj:GetName() .. "Cooldown"):Hide();
			obj.hasItem = nil;
			
			
			if self.db.profile.option.slot.empty.icon == true then
			
				getglobal( obj:GetName() .. "ArkBackground" ):SetTexture( "Interface\\Buttons\\UI-EmptySlot-White" );
				getglobal( obj:GetName() .. "ArkBackground" ):SetTexCoord( 0.20, 0.80, 0.20, 0.80 );
			
			else
			
				-- default background colour
				local colour = self.db.profile.option.slot.empty.colour.unknown
			
				-- get bag type
				local bt = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bag[bar.item[j].bag].type
			
	--ARKINV_G.SLOT_BANK, ARKINV_G.SLOT_KEY, ARKINV_G.SLOT_ENCHANTING, ARKINV_G.SLOT_ENGINEERING, ARKINV_G.SLOT_GEM, ARKINV_G.SLOT_MINING, 

				-- colour the backgrounds for different bag types
				if bt == ARKINV_G.SLOT_NORMAL then
					colour = self.db.profile.option.slot.empty.colour.normal
				elseif bt == ARKINV_G.SLOT_HERB then
					colour = self.db.profile.option.slot.empty.colour.herb
				elseif bt == ARKINV_G.SLOT_PROJECTILE then
					colour = self.db.profile.option.slot.empty.colour.projectile
				elseif bt == ARKINV_G.SLOT_SOUL then
					colour = self.db.profile.option.slot.empty.colour.soul
				end
			
				getglobal( obj:GetName() .. "ArkBackground" ):SetTexture( colour.r, colour.g, colour.b, 0.25 )
				
			end
			
		end
		
		obj.readable = i.readable;
		obj:Show();
	end

end

function ARKINV:GenerateBarBorder( name )

	for rownum, row in ipairs( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row ) do
		for barnum, bar in ipairs( row.bar ) do
			obj = getglobal( name .. "Bar" .. bar.frame );
			
			if self.db.profile.option.bar.border == true then
				obj:SetBackdropBorderColor( self.db.profile.option.bar.colour.border.r, self.db.profile.option.bar.colour.border.g, self.db.profile.option.bar.colour.border.b, 1 );
			else
				obj:SetBackdropBorderColor( 0, 0, 0, 0 )
			end
			
			if ARKINV_G.MODE_EDIT == true then
				obj:SetBackdropBorderColor( 1, 0, 0, 1 );
				getglobal( obj:GetName() .. "Background" ):SetTexture( 1, 0, 0, 0.1 );
				getglobal( obj:GetName() .. "Edit" ):Show();
			else
				getglobal( obj:GetName() .. "Background" ):SetTexture( self.db.profile.option.bar.colour.background.r, self.db.profile.option.bar.colour.background.g, self.db.profile.option.bar.colour.background.b, self.db.profile.option.bar.colour.background.a );
			end
			
			obj:Show();
		end
	end
	
end


function ARKINV:GenerateContainerRefresh()
	ARKINV_G.WINDOW_REFRESH = true
	self:GenerateContainer()
end


function ARKINV:GenerateContainerRebuild()
	--self:Categorise();
	ARKINV_G.WINDOW_REBUILD = true;
	ARKINV_G.WINDOW_REFRESH = true;
	self:GenerateContainer();
end


function ARKINV:GenerateContainer( )

	local frame = getglobal( ARKINV_G.GUI:GetName() .. "Container" )
	
	if ARKINV_G.WINDOW_REFRESH == false and ARKINV_G.WINDOW_REBUILD == false then
		return
	end

	if ARKINV_G.WINDOW_BUSY then
		return
	end
	ARKINV_G.WINDOW_BUSY = true

	
	-- exit if window isn't displayed
	if not frame:IsVisible() then
		ARKINV_G.WINDOW_BUSY = false
		return
	end
	
	self:Debug( "GenerateContainer() start" );

	local obj

	ARKINV_G.GUI:SetScale( self.db.profile.option.window.scale );
	
	for _, z in pairs( { ARKINV_G.GUI:GetChildren() } ) do
		obj = getglobal( z:GetName() .. "Background" );
		if obj then
			obj:SetTexture( self.db.profile.option.window.colour.background.r, self.db.profile.option.window.colour.background.g, self.db.profile.option.window.colour.background.b, self.db.profile.option.window.colour.background.a );
		end
	end



	
	-- set icons to correct images
	for x = 1, self:tableElements( ARKINV_G.LOCATION ) do
		obj = getglobal( ARKINV_G.GUI:GetName() .. "TitleLocation" .. x )
		local k = self:LocationGet( x );
		obj:SetNormalTexture( ARKINV_G.LOCATION[k].TEXTURE );
		if x > 1 then
			obj:SetPushedTexture( ARKINV_G.LOCATION[k].TEXTURE );
			obj:SetDisabledTexture( ARKINV_G.LOCATION[k].TEXTURE );
			obj:SetHighlightTexture( ARKINV_G.LOCATION[k].TEXTURE );
		end
	end
	
	-- are we online or offline?
	if ARKINV_G.CURRENT_USER == ARKINV_G.ME then

		ARKINV_G.MODE_OFFLINE = false;
		
		if ARKINV_G.CURRENT_LOCATION == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE_BANK == false then
			ARKINV_G.MODE_OFFLINE = true;
		end
	
	else
		ARKINV_G.MODE_OFFLINE = true;
	end


	--set title to correct text
	getglobal( ARKINV_G.GUI:GetName() .. "TitleProgram" ):SetText( ARKINV_G.PROGRAM_NAME .. " v" .. format( "%.2f", ARKINV_G.PROGRAM_VERSION ) );

	obj = getglobal( ARKINV_G.GUI:GetName() .. "TitleWho" );
	local t = strmatch( ARKINV_G.CURRENT_USER, " %- (.+)" ) .. " - " .. strmatch( ARKINV_G.CURRENT_USER, "(.+) %- " );
	if ARKINV_G.MODE_OFFLINE == true then
		obj:SetTextColor( 1, 0, 0 );
		t = strmatch( ARKINV_G.CURRENT_USER, " %- (.+)" ) .. " [" .. ARKINV_L["STATUS_OFFLINE"] .. "] - " .. strmatch( ARKINV_G.CURRENT_USER, "(.+) %- " );
	else
		obj:SetTextColor( 0, 1, 0 );
	end
	
	obj:SetText( t );
	

	
	if ARKINV_G.WINDOW_REBUILD == true then

		-- calculate numer of active slots
		self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].slot_count = self:tableSum( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bag, function( a ) return a.count; end );
		self:Debug( "slot count = " .. self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].slot_count )
	
		-- update maximum slots used so far
		if self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].slot_count > ARKINV_G.WINDOW_MAX_SLOT then
			ARKINV_G.WINDOW_MAX_SLOT = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].slot_count
		end

		self:Debug( "ARKINV_G.WINDOW_MAX_SLOT = " .. ARKINV_G.WINDOW_MAX_SLOT )


		-- break the inventory up into it's respective bars
		self:CalculateBars();

		


		
		-- calculate what the container should look like
		self:CalculateContainer();

		local name
	
		-- create (if required) and hide all the bar frames
		for j = 1, ARKINV_G.WINDOW_MAX_BAR do
			name = frame:GetName() .. "Bar" .. j
			obj = getglobal( name )
			if not obj then
				obj = CreateFrame( "Frame", name, frame, "ARVINVFrameBar" )
			end
			
			getglobal( name .. "Edit" ):Hide();
			
			obj:Hide()
		end

		local ename
	
		-- create (if required) and hide all the item and edit buttoms
		for j = 1, ARKINV_G.WINDOW_MAX_SLOT do
		
			name = frame:GetName() .. "Item" .. j
			obj = getglobal( name )
			if not ( obj ) then
				obj = CreateFrame( "Button", name, frame, "ARKINV_ItemButtonTemplate" )
			end
			obj:Hide()
			
			ARKINV_G.BAG_SLOT_SIZE = obj:GetWidth()

			getglobal( name .. "ArkBag" ):SetText()
			getglobal( name .. "ArkSlot" ):SetText()
			
			if ARKINV_G.MODE_EDIT == true or ARKINV_G.MODE_OFFLINE == true then
				-- disable clicks/drag when in edit mode or offline
				obj:RegisterForClicks();
				obj:RegisterForDrag();
				--obj:UnregisterEvent( "CURSOR_UPDATE" );
				--obj:UnregisterEvent( "BAG_UPDATE_COOLDOWN" );
			else
				obj:RegisterForClicks( "LeftButtonUp", "RightButtonUp" );
				obj:RegisterForDrag( "LeftButton" );
				--obj:RegisterEvent( "CURSOR_UPDATE" );
				--obj:RegisterEvent( "BAG_UPDATE_COOLDOWN" );
			end
		end

		
		self:Debug( "building window" )
	
		-- anchor the bar frames
		local pad_slot = self.db.profile.option.slot.pad
		local pad_bar = self.db.profile.option.bar.pad
		local rmw = 0 -- row max width - each row is not the same width and we need to use the largest when sizing the main window
	
		self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.width = 0;
		self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.height = ARKINV_G.WINDOW_OFFSET * 2;

		name = frame:GetName()
	
		for rownum, row in ipairs( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row ) do
	
			rmw = ARKINV_G.WINDOW_OFFSET * 2;
		
			for barnum, bar in ipairs( row.bar ) do

				obj = getglobal( name .. "Bar" .. bar.frame );
				obj:SetID( bar.id )
				
				-- self:Debug( "row=" .. rownum .. ", bar=" .. barnum .. ", obj=" .. obj:GetName() .. ", frame=" .. bar.frame )

				-- anchor first bar to frame
				if ( bar.frame == 1 ) then
					obj:SetPoint( "BOTTOMRIGHT", name, "BOTTOMRIGHT", 0 - ARKINV_G.WINDOW_OFFSET, ARKINV_G.WINDOW_OFFSET );
				else
					if ( barnum == 1 ) then
						-- next row, place under previous row
						-- self:Debug( "anchor=" .. name .. "Bar" .. self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row[rownum-1].bar[1].frame )
						obj:SetPoint( "BOTTOMRIGHT", name .. "Bar" .. self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row[rownum-1].bar[1].frame, "TOPRIGHT", 0, pad_bar );
					else
						-- next slot, place icon nxt to last one
						obj:SetPoint( "BOTTOMRIGHT", name .. "Bar" .. ( bar.frame - 1 ), "BOTTOMLEFT", 0 - pad_bar, 0 );
					end
				
				end
	
				obj:SetWidth( bar.width * ARKINV_G.BAG_SLOT_SIZE + ( bar.width + 1 ) * pad_slot + ARKINV_G.WINDOW_OFFSET * 2 );
				rmw = rmw + obj:GetWidth();
				if barnum > 1 then
					rmw = rmw + pad_bar
				end
				
				obj:SetHeight( bar.height * ARKINV_G.BAG_SLOT_SIZE + ( bar.height + 1 ) * pad_slot + ARKINV_G.WINDOW_OFFSET * 2 );
				
			end

			if rmw > self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.width then
				self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.width = rmw
			end
		
			self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.height = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.height + obj:GetHeight()

		end

		
		local x = ( self:tableElements( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row ) or 0 ) - 1
		if x > 0 then
			self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.height = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.height + pad_bar * x;
		end

		frame:SetWidth( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.width )
		frame:SetHeight( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.height )

		self:FrameUpdate();
		
	end

	
	-- display bar borders if required
	self:GenerateBarBorder( frame:GetName() );
	
	
	-- display item icons
	local boffset = 0
	for rownum, row in ipairs( self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.container.row ) do
		for barnum, bar in ipairs( row.bar ) do
			obj = getglobal( frame:GetName() .. "Bar" .. bar.frame );
			
			-- self:Debug( "bar frame=" .. obj:GetName() )
			
			self:GenerateBar( bar, obj, boffset )
			boffset = boffset + bar.count
		end
	end

	
	self:Debug( GREEN_FONT_COLOR_CODE .. "GenerateContainer() end " .. date() );

	ARKINV_G.WINDOW_REBUILD = false
	ARKINV_G.WINDOW_BUSY = false
	ARKINV_G.WINDOW_REFRESH = false
	
end


function ARKINV:ItemButton_OnEnter( button )

	if not ( button ) then
		button = this;
	end
	
	-- build tooltip because the blizzard template wont work with offline data
	bagnum = tonumber( getglobal( button:GetName() .. "ArkBag" ):GetText() );
	slotnum = tonumber( getglobal( button:GetName() .. "ArkSlot" ):GetText() );

	button:GetParent():SetID( bagnum );
	button:SetID( slotnum );
	
	local usemytooltip = false;

	local i = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bag[bagnum].slot[slotnum]
	
	if ( ( i.h ) and ( ARKINV_G.MODE_OFFLINE == true or bagnum == -1 or bagnum == -2 or ARKINV_G.EDIT_MODE == true ) ) then

		usemytooltip = true;
	
		local x;
		x = button:GetRight();
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			GameTooltip:SetOwner( button, "ANCHOR_LEFT" );
		else
			GameTooltip:SetOwner( button, "ANCHOR_RIGHT" );
		end

		if ARKINV_G.MODE_OFFLINE == true then
			-- offline, build tooltip from itemlink
			local s = strmatch( i.h, "(item:%d+:%d+:%d+:%d+:%d+:%d+:%d+:%d+)" );
			GameTooltip:SetHyperlink( s );
		elseif bagnum == -1 then
			-- bank slot
			GameTooltip:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) );
		elseif bagnum == -2 then
			-- keyring slot
			GameTooltip:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) );
		elseif ARKINV_G.EDIT_MODE == true then
			GameTooltip:SetBagItem( bagnum, slotnum );
		end

		GameTooltip:Show();
		
	end
	
	return usemytooltip;
	
end


function ARKINV:UpdateCooldown( obj )

	bag = tonumber( getglobal( obj:GetName() .. "ArkBag" ):GetText() )
	slot = tonumber( getglobal( obj:GetName() .. "ArkSlot" ):GetText() )
	
	local cooldown = getglobal( obj:GetName() .. "Cooldown" );
	local start, duration, enable = GetContainerItemCooldown( bag, slot );
	CooldownFrame_SetTimer( cooldown, start, duration, enable );
	if ( duration > 0 and enable == 0 ) then
		SetItemButtonTextureVertexcolour( obj, 0.4, 0.4, 0.4 );
	end
	
end


function ARKINV:ItemCategoryID( cat )

	-- self:Debug( "ItemCategoryID( " .. cat .. " )" );

	for _, v in pairs( ARKINV_G.CATEGORY ) do
		if cat == v.name then
			return v.id
		end
	end
	
	return 0 -- default
	
end

function ARKINV:ItemSoulbound( i, bagnum, slotnum )

	if i.sb then
		--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " already marked as soulbound" )
		return true
	end
	
	if i.h then
	
		if self:IsTooltipReliable( bagnum ) == false then
			--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " offline tooltip" )
			-- offline, build tooltip from itemlink
			local s = strmatch( i.h, "(item:%d+:%d+:%d+:%d+:%d+:%d+:%d+:%d+)" );
			gt:SetHyperlink( s );
		elseif bagnum == -1 then
			-- bank slot
			--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " bank tooltip" )
			gt:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) );
		elseif bagnum == -2 then
			-- keyring slot
			--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " keyring tooltip" )
			gt:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) );
		else
			--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " standard tooltip" )
			gt:SetBagItem( bagnum, slotnum );
		end
	
		if gt:Find( ARKINV_L["TOOLTIP_SOULBOUND"] ) then
			--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " found soulbound in tooltip" )
			return true
		end
		
	end
	
	return false
	
end

function ARKINV:ItemCategoryGetDefault( i, bt, bagnum, slotnum )
	
	if not ( i.h ) then
		-- empty slot
		
		-- self:Debug( "ItemCategoryGetDefault( nil, " .. bt .. " )" )

		local clump = self.db.profile.option.slot.empty.clump
		
		if bt == ARKINV_G.SLOT_PROJECTILE then
		
			if clump == true then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_PROJECTILE"] )
			end
			
		elseif bt == ARKINV_G.SLOT_KEY then
		
			if clump == true then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_KEY"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_KEY"] )
			end
			
		elseif bt == ARKINV_G.SLOT_SOUL then
		
			if clump == true then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_SOUL"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_SOUL"] )
			end
			
		elseif bt == ARKINV_G.SLOT_HERB then
		
			if clump == true then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_HERBALISM"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_HERB"] )
			end
						
		elseif bt == ARKINV_G.SLOT_ENCHANTING then
		
			if clump == true then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_ENCHANTING"] )
			end
			
		elseif bt == ARKINV_G.SLOT_ENGINEERING then
		
			if clump == true then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_ENGINEERING"] )
			end
			
		elseif bt == ARKINV_G.SLOT_GEM then
		
			if clump == true then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_GEM"] )
			end
			
		elseif bt == ARKINV_G.SLOT_MINING then
		
			if clump == true then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_MINING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_MINING"] )
			end
			
			
		end
		
		return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY"] )

	end
	

	local n, _, q, _, _, t, s = GetItemInfo( i.h )
		
	-- self:Debug( "ItemCategoryGetDefault( " .. h .. ", " .. bt .. " ) t=" .. t .. ", s=" .. s, "00ff00" )

	-- trash
	if q == 0 then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_TRASH"] )
	end
		
	-- basic item types
	if t == ARKINV_L["ITEM_PROJECTILE"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE"] )
	end

	if t == ARKINV_L["ITEM_QUEST"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_QUEST"] )
	end
		
		
	if t == ARKINV_L["ITEM_RECIPE"] then
	
		if s == ARKINV_L["ITEM_PROFESSION_ALCHEMY"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ALCHEMY"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_BLACKSMITHING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_BLACKSMITHING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_COOKING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_COOKING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_ENCHANTING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_ENGINEERING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_FIRST_AID"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_FIRST_AID"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_JEWELCRAFTING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_LEATHERWORKING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_LEATHERWORKING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_TAILORING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_TAILORING"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_RECIPE"] )
		end
		
	end


	-- tooltip scanning
	if self:IsTooltipReliable( bagnum ) == false then
		-- offline, build tooltip from itemlink
		local s = strmatch( i.h, "(item:%d+:%d+:%d+:%d+:%d+:%d+:%d+:%d+)" );
		gt:SetHyperlink( s );
	elseif bagnum == -1 then
		-- bank slot
		gt:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) );
	elseif bagnum == -2 then
		-- keyring slot
		gt:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) );
	else
		gt:SetBagItem( bagnum, slotnum );
	end

	
	if i.sb or gt:Find( ARKINV_L["TOOLTIP_SOULBOUND"], 1, 4 ) then
	
		--self:Debug( "soulbound default, bag=" .. bagnum .. ", slot=" .. slotnum .. ", link=" .. i.h )
		if t == ARKINV_L["ITEM_ARMOR"] or t == ARKINV_L["ITEM_WEAPON"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULBOUND_EQUIPMENT"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULBOUND"] )
		end
		
	elseif gt:Find( ARKINV_L["TOOLTIP_MOUNT"] ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_MOUNT"] )
	elseif gt:Find( ARKINV_L["TOOLTIP_POTION"] ) or gt:Find( ARKINV_L["TOOLTIP_ELIXIR"] ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_CONSUMABLE"] )
	end

		
	-- other item types
	if t == ARKINV_L["ITEM_ARMOR"] or t == ARKINV_L["ITEM_WEAPON"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_EQUIPMENT"] )
	end

	
	-- profession items, or at least items that require something
	local req = gt:GetLine( 2 )
	if req and strfind( req, ARKINV_L["ITEM_REQUIRES"] ) then
	
		if strfind( req, ARKINV_L["ITEM_PROFESSION_ALCHEMY"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ALCHEMY"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_BLACKSMITHING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_BLACKSMITHING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_COOKING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_COOKING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_ENCHANTING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_ENGINEERING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_FIRST_AID"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_FIRST_AID"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_FISHING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_FISHING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_HERBALISM"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_HERBALISM"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_JEWELCRAFTING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_LEATHERWORKING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_LEATHERWORKING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_MINING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_MINING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_SKINNING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_SKINNING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_TAILORING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_TAILORING"] )
		end
		
	end


	-- more tooltip scanning
	if gt:Find( ARKINV_L["TOOLTIP_CLASS"] ) then

		if gt:Find( ARKINV_L["TOOLTIP_CLASS_DRUID"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_DRUID"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_HUNTER"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_HUNTER"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_MAGE"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_MAGE"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_PALADIN"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_PALADIN"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_PRIEST"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_PRIEST"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_ROGUE"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_ROGUE"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_SHAMAN"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_SHAMAN"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_WARLOCK"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_WARLOCK"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_WARRIOR"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_WARRIOR"] )
		end

	end
	
	
	-- fallback for any item not categorised
	return self:ItemCategoryID( ARKINV_L["CATEGORY_DEFAULT"] )
	
end


function ARKINV:ItemCategoryGet( i, bt, bagnum, slotnum )
	
	-- returns category, [ default category]
	
	--self:Debug( "ItemCategoryGet() start" )
	
	if not i.h then
	
		--self:Debug( "empty slot" )
		-- empty slot
		return self:ItemCategoryGetDefault( i, bt, bagnum, slotnum ), nil

	end
	
	-- self:Debug( "ItemCategoryGet( " .. h .. ", " .. bt .. " )" )
	-- check overrides
	
	if self.db.profile.option.category.item[i.id] then  -- k is a string, not a number
		return self.db.profile.option.category.item[i.id], self:ItemCategoryGetDefault( i, bt, bagnum, slotnum )
	end
	
	-- return default
	return self:ItemCategoryGetDefault( i, bt, bagnum, slotnum ), nil

	--self:Debug( "ItemCategoryGet() end" )
	
end


function ARKINV:ItemCategorySet( tblItem, category_id )
	-- set cat to nil to reset
	self.db.profile.option.category.item[tblItem.id] = category_id
	self:ItemCategoryReload( tblItem )
end


function ARKINV:ItemCategoryReload( tblItem )

	--self:Debug( "ItemCategoryReload() start" );

	local c = nil;
	local cd = nil;
	
	if tblItem.id then
		for name, who in pairs( self.db.account.cache.who ) do
			for _, location in pairs( who.location ) do
				for bagnum, bag in pairs( location.inventory.bag ) do
					for slotnum, slot in pairs( bag.slot ) do
						if slot.id == tblItem.id then
							if not c then
								-- only get the category for the first match, use the same values for the rest
								c, cd = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum )
							end
							slot["cat"] = c
							slot["catdef"] = cd
						end
					end
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReload() end" );
	
end


function ARKINV:ItemCategoryReloadEmpty()

	--self:Debug( "ItemCategoryReloadEmpty() start" );
	
	for name, who in pairs( self.db.account.cache.who ) do
		for _, location in pairs( who.location ) do
			for bagnum, bag in pairs( location.inventory.bag ) do
				for slotnum, slot in pairs( bag.slot ) do
					if not slot.h then
						slot["cat"], slot["catdef"] = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum )
					end
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReloadEmpty() end" );
	
end


function ARKINV:BagLocation( id )

	if id == -2 then
		return ARKINV_G.LOCATION_KEY;
	elseif id >= 0 and id <= 4 then
		return ARKINV_G.LOCATION_BAG;
	elseif id == -1 or ( id >= 5 and id <= 11 ) then
		return ARKINV_G.LOCATION_BANK;
	end
	
	
	self:Print( RED_FONT_COLOR_CODE .. "BagLocation( " .. id .. " ), value not coded" )
	return nil

end

function ARKINV:BagType( id )

	if id == -2 then
		return ARKINV_G.SLOT_KEY
	elseif id == -1 or id == 0 then
		return ARKINV_G.SLOT_NORMAL
	end

	local h = GetInventoryItemLink( "player", ContainerIDToInventoryID( id ) )
	
	if not h then
	
		-- no bag in slot
		return ARKINV_G.SLOT_NORMAL
	
	else
	
		local t, s = select( 6, GetItemInfo( h ) )

		if t == ARKINV_L["ITEM_CONTAINER"] then
			if s == ARKINV_L["ITEM_CONTAINER_BAG"] then
				return ARKINV_G.SLOT_NORMAL
			elseif s == ARKINV_L["ITEM_CONTAINER_SOUL"] then
				return ARKINV_G.SLOT_SOUL
			elseif s == ARKINV_L["ITEM_CONTAINER_HERB"] then
				return ARKINV_G.SLOT_HERB
			elseif s == ARKINV_L["ITEM_CONTAINER_ENCHANTING"] then
				return ARKINV_G.SLOT_ENCHANTING
			elseif s == ARKINV_L["ITEM_CONTAINER_ENGINEERING"] then
				return ARKINV_G.SLOT_ENGINEERING
			elseif s == ARKINV_L["ITEM_CONTAINER_GEM"] then
				return ARKINV_G.SLOT_GEM
			elseif s == ARKINV_L["ITEM_CONTAINER_MINING"] then
				return ARKINV_G.SLOT_MINING
			else
				return ARKINV_G.SLOT_UNKNOWN
			end
		elseif t == ARKINV_L["ITEM_QUIVER"] then
			return ARKINV_G.SLOT_PROJECTILE
		else
			-- not a bag????
			return ARKINV_G.SLOT_UNKNOWN
		end
		
	end

end

function ARKINV:BagTypeText( id )

	if id == ARKINV_G.SLOT_KEY then
		return ARKINV_L["NAME_CONTAINER_KEY"]
	elseif id == ARKINV_G.SLOT_PROJECTILE then
		return ARKINV_L["NAME_CONTAINER_PROJECTILE"]
	elseif id == ARKINV_G.SLOT_SOUL then
		return ARKINV_L["NAME_CONTAINER_SOUL"]
	elseif id == ARKINV_G.SLOT_HERB then
		return ARKINV_L["NAME_CONTAINER_HERB"]
	elseif id == ARKINV_G.SLOT_ENCHANTING then
		return ARKINV_L["NAME_CONTAINER_ENCHANTING"]
	elseif id == ARKINV_G.SLOT_ENGINEERING then
		return ARKINV_L["NAME_CONTAINER_ENGINEERING"]
	elseif id == ARKINV_G.SLOT_GEM then
		return ARKINV_L["NAME_CONTAINER_GEM"]
	elseif id == ARKINV_G.SLOT_MINING then
		return ARKINV_L["NAME_CONTAINER_MINING"]
	else
		return "Norm"
	end
	
end



function ARKINV:OptionMenuOpen()

	if dd:IsOpen( this ) then
	
		dd:Close()
		
	else
	
		dd:Open( this,
			"point", "TOPLEFT",
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
			
					dd:AddLine( "text", "OPTIONS", "isTitle", true, "textHeight", 12 );

					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine(	"text", "Edit Mode",
						"tooltipTitle", "Edit Mode",
						"tooltipText", "toggles edit mode on and off so you can customise which items and categories are displayed on which bars",
						"checked", ARKINV_G.MODE_EDIT,
						"func", function()
							ARKINV_G.MODE_EDIT = not ARKINV_G.MODE_EDIT;
							dd:Close();
							self:GenerateContainerRebuild();
						end
					);

					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", "Window",
						"hasArrow", true,
						"value", "WINDOW"
					);
	
					dd:AddLine( "text", "Bars",
						"hasArrow", true,
						"value", "BAR"
					);
					
					dd:AddLine( "text", "Items",
						"hasArrow", true,
						"value", "ITEM"
					)
					
					dd:AddLine( "text", "Sorting",
						"hasArrow", true,
						"value", "SORT"
					);
					
				end

					
				if level == 2 then
				
					if value == "WINDOW" then
					
						dd:AddLine( "text", "Width",
							"tooltipTitle", "Width",
							"tooltipText", "number of columns to display",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self.db.profile.option.window.col,
							"sliderMin", 8,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self.db.profile.option.window.col then
									self.db.profile.option.window.col = v;
									self:GenerateContainerRebuild();
								end
							end
						);
						dd:AddLine( "text", "Auto open",
							"hasArrow", true,
							"value", "AUTO_OPEN"
						);
						dd:AddLine( "text", "Auto close",
							"hasArrow", true,
							"value", "AUTO_CLOSE"
						);
						dd:AddLine( "text", "Scale",
							"tooltipTitle", "Scale",
							"tooltipText", "scale the interface making it larger or smaller",
							"hasArrow", true,
							"hasSlider", true,
							"sliderIsPercent", true,
							"sliderValue", self.db.profile.option.window.scale,
							"sliderMin", .4,
							"sliderMax", 2,
							"sliderStep", .05,
							"sliderFunc", function( v )
								if v ~= self.db.profile.option.window.scale then
									self.db.profile.option.window.scale = v;
									self:GenerateContainerRebuild();
								end
							end
						);
						dd:AddLine( "text", "Background Colour",
							"hasColorSwatch", true,
							"hasOpacity", true,
							"r", self.db.profile.option.window.colour.background.r,
							"g", self.db.profile.option.window.colour.background.g,
							"b", self.db.profile.option.window.colour.background.b,
							"opacity", self.db.profile.option.window.colour.background.a,
							"colorFunc", function( r, g, b, a )
								self.db.profile.option.window.colour.background.r = r;
								self.db.profile.option.window.colour.background.g = g;
								self.db.profile.option.window.colour.background.b = b;
								self.db.profile.option.window.colour.background.a = a;
								self:GenerateContainerRefresh();
							end
						);
					
					end
					
					if value == "BAR" then
						
						dd:AddLine(	"text", "Per Row",
							"tooltipTitle", "Bars per Row",
							"tooltipText", "the number of bars to display in each row",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self.db.profile.option.bar.per,
							"sliderMin", 1,
							"sliderMax", 8,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self.db.profile.option.bar.per then
									self.db.profile.option.bar.per = v;
									self:GenerateContainerRebuild();
								end
							end
						);
						dd:AddLine( "text", "Padding",
							"tooltipTitle", "Bar Padding",
							"tooltipText", "the amount of space to add between bars",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self.db.profile.option.bar.pad,
							"sliderMin", 0,
							"sliderMax", 64,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self.db.profile.option.bar.pad then
									self.db.profile.option.bar.pad = v;
									self:GenerateContainerRebuild();
								end
							end
						);
						dd:AddLine( "text", "Border",
							"tooltipTitle", "Bar Borders",
							"tooltipText", "toggles the display of a border around each bar",
							"checked", self.db.profile.option.bar.border,
							"func", function()
								self.db.profile.option.bar.border = not self.db.profile.option.bar.border;
								self:GenerateContainerRefresh();
							end
						);
						if self.db.profile.option.bar.border == true then
						dd:AddLine( "text", "Border Colour",
							"hasColorSwatch", true,
							"r", self.db.profile.option.bar.colour.border.r,
							"g", self.db.profile.option.bar.colour.border.g,
							"b", self.db.profile.option.bar.colour.border.b,
							"colorFunc", function( r, g, b )
								self.db.profile.option.bar.colour.border.r = r;
								self.db.profile.option.bar.colour.border.g = g;
								self.db.profile.option.bar.colour.border.b = b;
								self:GenerateContainerRefresh();
							end
						);
						end
						dd:AddLine( "text", "Background Colour",
							"hasColorSwatch", true,
							"hasOpacity", true,
							"r", self.db.profile.option.bar.colour.background.r,
							"g", self.db.profile.option.bar.colour.background.g,
							"b", self.db.profile.option.bar.colour.background.b,
							"opacity", self.db.profile.option.bar.colour.background.a,
							"colorFunc", function( r, g, b, a )
								self.db.profile.option.bar.colour.background.r = r;
								self.db.profile.option.bar.colour.background.g = g;
								self.db.profile.option.bar.colour.background.b = b;
								self.db.profile.option.bar.colour.background.a = a;
								self:GenerateContainerRefresh();
							end
						);
						dd:AddLine( "text", "Reset to Defaults",
							"tooltipTitle", "Reset",
							"tooltipText", "resets the bar options back to the default values",
							"func", function()
								-- !!!
								self:DefaultOptionBar();
								self:GenerateContainerRebuild();
							end
						);
					
					end
					
					if value == "ITEM" then
					
						dd:AddLine( "text", "", "disabled", true )
						dd:AddLine( "text", "Item Slots:", "isTitle", true )
						dd:AddLine( "text", "Padding",
							"tooltipTitle", "Slot Padding",
							"tooltipText", "the amount of space to add between item slots",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self.db.profile.option.slot.pad,
							"sliderMin", 2,
							"sliderMax", 16,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self.db.profile.option.slot.pad then
									self.db.profile.option.slot.pad = v;
									self:GenerateContainerRebuild();
								end
							end
						)
						dd:AddLine( "text", "Colour empty slots",
							"tooltipTitle", "Colour empty slots",
							"tooltipText", "colour empty slots depending on bag type or just show the backdrop icon",
							"checked", self.db.profile.option.slot.empty.icon == false,
							"func", function()
								self.db.profile.option.slot.empty.icon = not self.db.profile.option.slot.empty.icon;
								self:GenerateContainerRefresh();
							end
						);
						dd:AddLine( "text", "Clump empty slots",
							"tooltipTitle", "Clump empty slots",
							"tooltipText", "toggles wether empty slots are clumped in together with their non-empty type slots or treated as a seperate category",
							"checked", self.db.profile.option.slot.empty.clump,
							"func", function()
								self.db.profile.option.slot.empty.clump = not self.db.profile.option.slot.empty.clump;
								self:ItemCategoryReloadEmpty();
								self:GenerateContainerRebuild();
							end
						);
						dd:AddLine( "text", "Fade offline items",
							"tooltipTitle", "Fade offline items",
							"tooltipText", "fades the items to grey when they are offline",
							"checked", self.db.profile.option.slot.fade == true,
							"func", function()
								self.db.profile.option.slot.fade = not self.db.profile.option.slot.fade;
								self:GenerateContainerRefresh();
							end
						);
						dd:AddLine( "text", "Rarity coloured border",
							"tooltipTitle", "Slot border colour",
							"tooltipText", "colour the border around each item slot to match it's rarity (Common, Rare, Epic, etc)",
							"checked", self.db.profile.option.slot.border,
							"func", function()
								self.db.profile.option.slot.border = not self.db.profile.option.slot.border;
								self:GenerateContainerRebuild();
							end
						);
						dd:AddLine( "text", "Highlight New",
							"disabled", true,
							"tooltipTitle", "Highlight New",
							"tooltipText", "highlights recently updated items making them easier to see",
							"checked", self.db.profile.option.slot.new,
							"func", function()
								self.db.profile.option.slot.new = not self.db.profile.option.slot.new;
								self:GenerateContainerRefresh();
							end
						);
						dd:AddLine( "text", "Reset to Defaults",
							"disabled", true,
							"tooltipTitle", "Reset",
							"tooltipText", "resets the item slot options back to the default values",
							"func", function()
								self:DefaultOptionSlot();
								self:GenerateContainerRebuild();
							end
						);
		
					end
					
					if value == "SORT" then
					
						dd:AddLine( "text", "By Name",
							"isRadio", true,
							"checked", self.db.profile.option.slot.sort == ARKINV_G.SLOT_SORT_NAME,
							"func", function()
								self.db.profile.option.slot.sort = ARKINV_G.SLOT_SORT_NAME;
								self:GenerateContainerRefresh();
							end
						)

						dd:AddLine( "text", "By Bag",
							"isRadio", true,
							"checked", self.db.profile.option.slot.sort == ARKINV_G.SLOT_SORT_BAGSLOT,
							"func", function()
								self.db.profile.option.slot.sort = ARKINV_G.SLOT_SORT_BAGSLOT;
								self:GenerateContainerRefresh();
							end
						)

						dd:AddLine(	"text", "No Sorting",
							"isRadio", true,
							"checked", self.db.profile.option.slot.sort == ARKINV_G.SLOT_SORT_NONE,
							"func", function()
								self.db.profile.option.slot.sort = ARKINV_G.SLOT_SORT_NONE;
								self:GenerateContainerRefresh();
							end
						)
						
					end
				
				end
				
				if level == 3 then
				
					if value == "AUTO_OPEN" then

						dd:AddLine( "text", "Bank",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open the bank",
							"checked", self.db.profile.option.window.auto.open.bank,
							"func", function()
								self.db.profile.option.window.auto.open.bank = not self.db.profile.option.window.auto.open.bank;
							end
						);
						dd:AddLine( "text", "Mailbox",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open the mailbox",
							"checked", self.db.profile.option.window.auto.open.mail,
							"func", function()
								self.db.profile.option.window.auto.open.mail = not self.db.profile.option.window.auto.open.mail;
							end
						);
						dd:AddLine( "text", "Merchant",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you talk to a merchant",
							"checked", self.db.profile.option.window.auto.open.merchant,
							"func", function()
								self.db.profile.option.window.auto.open.merchant = not self.db.profile.option.window.auto.open.merchant;
							end
						);
						dd:AddLine( "text", "Trade",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open a trade",
							"checked", self.db.profile.option.window.auto.open.trade,
							"func", function()
								self.db.profile.option.window.auto.open.trade = not self.db.profile.option.window.auto.open.trade;
							end
						);
						dd:AddLine( "text", "Auction House",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open the auction house",
							"checked", self.db.profile.option.window.auto.open.auction,
							"func", function()
								self.db.profile.option.window.auto.open.auction = not self.db.profile.option.window.auto.open.auction;
							end
						);
					
					end
					
					if value == "AUTO_CLOSE" then
					
						dd:AddLine( "text", "Bank",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave the bank",
							"checked", self.db.profile.option.window.auto.close.bank,
							"func", function()
								self.db.profile.option.window.auto.close.bank = not self.db.profile.option.window.auto.close.bank;
							end
						);
						dd:AddLine( "text", "Mailbox",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave the mailbox",
							"checked", self.db.profile.option.window.auto.close.mail,
							"func", function()
								self.db.profile.option.window.auto.close.mail = not self.db.profile.option.window.auto.close.mail;
							end
						);
						dd:AddLine( "text", "Merchant",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave a merchant",
							"checked", self.db.profile.option.window.auto.close.merchant,
							"func", function()
								self.db.profile.option.window.auto.close.merchant = not self.db.profile.option.window.auto.close.merchant;
							end
						);
						dd:AddLine( "text", "Trade",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you close a trade",
							"checked", self.db.profile.option.window.auto.close.trade,
							"func", function()
								self.db.profile.option.window.auto.close.trade = not self.db.profile.option.window.auto.close.trade;
							end
						);
						dd:AddLine( "text", "Auction House",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave the auction house",
							"checked", self.db.profile.option.window.auto.close.auction,
							"func", function()
								self.db.profile.option.window.auto.close.auction = not self.db.profile.option.window.auto.close.auction;
							end
						);
						dd:AddLine( "text", "Combat",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you enter combat",
							"checked", self.db.profile.option.window.auto.close.combat,
							"func", function()
								self.db.profile.option.window.auto.close.combat = not self.db.profile.option.window.auto.close.combat;
							end
						);
						
					end
					
				
				end
				
			end
			
		)

	end
	
end


function ARKINV:BarMenuOpen( bar )

	if dd:IsOpen( this ) then

		dd:Close()
		
	else

		local barnum = this:GetParent():GetID()
		
		local cat_type = {
			[1] = "SYSTEM",
			[2] = "PROFESSION",
			[3] = "CLASS",
			[4] = "CUSTOM",
		}
		
		dd:Open( this,
			"point", "TOPLEFT",
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
				
					dd:AddLine( "text", "BAR " .. barnum .. " CATEGORIES", "isTitle", true, "textHeight", 12 );
					
					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", "Currently Assigned:", "isTitle", true );
			
					for _, cat in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do
					
						local t = cat.type
						if self.db.profile.option.category.location[cat.id] == barnum then
							-- assigned ategories for this bar - displayed in green
							dd:AddLine( "text", GREEN_FONT_COLOR_CODE .. cat.name .. FONT_COLOR_CODE_CLOSE,
								"tooltipTitle", "Category",
								"tooltipText", "click to remove " .. cat.name .. " from this bar and return it to the default bar",
								"func", function()
									self.db.profile.option.category.location[cat.id] = nil;
									self:GenerateContainerRebuild();
								end
							);

						end
						
					end

					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", "Assignable Categories:", "isTitle", true );
					
					for _, v in ipairs( cat_type ) do
						dd:AddLine( "text", v,
							"hasArrow", true,
							"value", "CATEGORY_" .. v
						);
					end
					
				elseif level == 2 then

						for _, cat in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do
					
							local t = cat.type
							if self.db.profile.option.category.location[cat.id] == barnum then
								t = "CATEGORY_HIDDEN"
							end
							
							--self:Debug( "id=" .. cat.id .. ", type=[" .. cat.type .. "], value=[" .. value .. "]" )
							local n = cat.name
							
							if value == t then
								
								if self.db.profile.option.category.location[cat.id] then
									-- category is assigned to a bar - show the user where
									n = LIGHTYELLOW_FONT_COLOR_CODE .. n .. " [" .. self.db.profile.option.category.location[cat.id] .. "]" .. FONT_COLOR_CODE_CLOSE
								end
								
								dd:AddLine( "text", n,
									"tooltipTitle", "Category",
									"tooltipText", cat.name,
									"func", function()
										self.db.profile.option.category.location[cat.id] = barnum;
										self:GenerateContainerRebuild();
									end
								);
							end
							
						end

				end
				
			end
		)

	end
	
end


function ARKINV:ItemMenuOpen( level )

	if ARKINV_G.MODE_EDIT == false then
		return
	end

	if dd:IsOpen( this ) then
	
		dd:Close()
		
	else
	
		local bag = tonumber( getglobal( this:GetName() .. "ArkBag" ):GetText() )
		local slot = tonumber( getglobal( this:GetName() .. "ArkSlot" ):GetText() )
		
		local i = self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].inventory.bag[bag].slot[slot];
		local _, _, _, ic = GetItemQualityColor( i.q );
		local barnum = self:GetCategoryLocation( i.cat )
		
		local cat_type = {
			[1] = "SYSTEM",
			[2] = "PROFESSION",
			[3] = "CLASS",
			[4] = "CUSTOM",
		}
	
	
		dd:Open( this,
			"point", "TOPLEFT",
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
			
					dd:AddLine( "text", "ITEM OPTIONS:", "isTitle", true, "textHeight", 12 );

					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", ic .. i.name .. FONT_COLOR_CODE_CLOSE, "isTitle", true, "textHeight", 12 );
					
					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", "Location: " .. LIGHTYELLOW_FONT_COLOR_CODE .. "Bag " .. bag .. ", Slot " .. slot .. FONT_COLOR_CODE_CLOSE, "notClickable", true );
					dd:AddLine( "text", "Currently Assigned: " .. GREEN_FONT_COLOR_CODE .. self:GetCategoryName( i.cat ) .. FONT_COLOR_CODE_CLOSE,
						"notClickable", true
					);

					if ( i.catdef ) and i.catdef ~= i.cat then
						dd:AddLine( "text", "Reset to Default: " .. LIGHTYELLOW_FONT_COLOR_CODE .. self:GetCategoryName( i.catdef ) .. FONT_COLOR_CODE_CLOSE,
							"tooltipTitle", "Reset to Default Category",
							"tooltipText", "reset the category for this item back to it's default value",
							"func", function()
								dd:Close();
								self:ItemCategorySet( i, nil );
								self:GenerateContainerRebuild();
							end
						);
					end
				
					dd:AddLine( "text", "", "disabled", true )
					dd:AddLine( "text", "Assignable Categories:", "isTitle", true )
					for _, v in ipairs( cat_type ) do
						dd:AddLine( "text", v,
							"hasArrow", true,
							"tooltipTitle", "Assign Category",
							"tooltipText", "assign this item to a specific category",
							"value", "CATEGORY_" .. v
						);
					end
					
					dd:AddLine( "text", "", "disabled", true )
					dd:AddLine(	"text", "Move " .. LIGHTYELLOW_FONT_COLOR_CODE .. self:GetCategoryName( i.cat ) .. FONT_COLOR_CODE_CLOSE .. " to Bar",
						"hasArrow", true,
						"hasSlider", true,
						"sliderValue", barnum,
						"sliderMin", 1,
						"sliderMax", self.db.account.cache.who[ARKINV_G.CURRENT_USER].location[ARKINV_G.CURRENT_LOCATION].bar_count + 1,
						"sliderStep", 1,
						"sliderFunc", function( v )
							self.db.profile.option.category.location[i.cat] = v;
							self:GenerateContainerRebuild();
						end
					)
				
				end

				if level == 2 then

					if value and string.sub( value, 1, 9 ) == "CATEGORY_" then
					
						for _, v in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do
					
							local t = v.type
							if v.id == i.cat then
								t = "CATEGORY_HIDDEN"
							end
							
							--self:Debug( "id=" .. cat.id .. ", type=[" .. cat.type .. "], value=[" .. value .. "]" )
							if value == t then
							
								dd:AddLine( "text", v.name,
									"tooltipTitle", "Assign Category",
									"tooltipText", "assign this item to the " .. v.name .. " category",
									"func", function()
										dd:Close();
										self:ItemCategorySet( i, v.id );
										self:GenerateContainerRebuild();
									end
								);
							
							end
							
						end
						
					end
					
				end

			end
		);
		
	end
	
end


function ARKINV:LocationMenuOpen( level )

	local n, b;

	if dd:IsOpen( this ) then
	
		dd:Close()
		
	else
	
		dd:Open( this,
			"point", "TOPLEFT",
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then

					for k, v in pairs( self.db.account.cache.who ) do
						n = k
						if k == ARKINV_G.ME then
							n = GREEN_FONT_COLOR_CODE .. n .. FONT_COLOR_CODE_CLOSE
						end

						if k ~= ARKINV_G.CURRENT_USER then
							dd:AddLine(	"text", n,
								"textHeight", 14,
								"isRadio", true,
								"checked", k == ARKINV_G.CURRENT_USER,
								"func", function()
									ARKINV_G.CURRENT_USER = k;
									dd:Close();
									self:GenerateContainerRebuild();
								end
							);
						end
					end
					
				end

			end
		);
		
	end
	
end


function ARKINV:LocationGet( id )

	for x = 1, self:tableElements( ARKINV_G.LOCATION ) do
		if ARKINV_G.LOCATION[x].ORDER == id then
			return x
		end
	end

	return nil
	
end


function ARKINV:LocationIconSwap( id )

	-- swap whatever is at order 1 with order id

	a1 = self:LocationGet( 1 );
	o1 = ARKINV_G.LOCATION[a1].ORDER;
	
	a2 = self:LocationGet( id );
	o2 = ARKINV_G.LOCATION[a2].ORDER;
	
	ARKINV_G.LOCATION[a1].ORDER = o2;
	ARKINV_G.LOCATION[a2].ORDER = o1;
	
	ARKINV_G.CURRENT_LOCATION = self:LocationGet( 1 );
	
end


function ARKINV:LocationChange( new_location, new_user )

	local location = new_location or ARKINV_G.LOCATION_BAG;
	local user = new_user or ARKINV_G.ME;
	
	--self:Debug( "old location=" .. ARKINV_G.CURRENT_LOCATION .. ", old user=" .. ARKINV_G.CURRENT_USER );

	if location ~= ARKINV_G.CURRENT_LOCATION then
		--self:Debug( "new location=" .. location );
		self:LocationIconSwap( ARKINV_G.LOCATION[location].ORDER );
		ARKINV_G.WINDOW_REBUILD = true;
	end
	
	if user ~= ARKINV_G.CURRENT_USER then
		--self:Debug( "new user=" .. user );
		ARKINV_G.CURRENT_USER = ARKINV_G.ME;
		ARKINV_G.WINDOW_REBUILD = true;
	end
	
end


function ARKINV:IsTooltipReliable( bagnum )

	local r = true;
	
	if ARKINV_G.CURRENT_USER == ARKINV_G.ME then
	
		if ( ( bagnum == -1 or bagnum >= 5 ) and ARKINV_G.MODE_BANK == false ) then
			r = false;
		end
	
	else
		r = false;
	end

	return r
	
end


function ARKINV:RemoveOldOptions()
	self:ResetDB( "char" );
	
	if self.db.profile.option.window["background"] then
		self.db.profile.option.window.colour.background = self.db.profile.option.window.background;
		self.db.profile.option.window.background = nil;
	end
	
	if self.db.profile.option.window["combat"] then
		self.db.profile.option.window.auto.close.combat = self.db.profile.option.window.combat;
		self.db.profile.option.window.combat = nil;
	end
	
end
